coap_pdu_t Struct Reference

structure for CoAP PDUs token, if any, follows the fixed size header, then options until payload marker (0xff), then the payload if stored inline. More...

`#include <pdu.h>`

## Data Fields

uint8_t | type
| message type More...
uint8_t | code
| request method (value 1–10) or response code (value 40-255) More...
uint8_t | max_hdr_size
| space reserved for protocol-specific header More...
uint8_t | hdr_size
| actaul size used for protocol-specific header More...
uint8_t | token_length
| length of Token More...
uint16_t | tid
| transaction id, if any, in regular host byte order More...
uint16_t | max_delta
| highest option number More...
size_t | alloc_size
| allocated storage for token, options and payload More...
size_t | used_size
| used bytes of storage for token, options and payload More...
size_t | max_size
| maximum size for token, options and payload, or zero for variable size pdu More...
uint8_t * | token
| first byte of token, if any, or options More...
uint8_t * | data
| first byte of payload, if any More...

## Detailed Description

structure for CoAP PDUs token, if any, follows the fixed size header, then options until payload marker (0xff), then the payload if stored inline.

Memory layout is: <—header—>|<—token—><—options—>0xff<—payload—> header is addressed with a negative offset to token, its maximum size is max_hdr_size. options starts at token + token_length payload starts at data, its length is used_size - (data - token)

Definition at line 285 of file pdu.h.

## Field Documentation

## alloc_size

size_t coap_pdu_t::alloc_size

allocated storage for token, options and payload

Definition at line 293 of file pdu.h.

## code

uint8_t coap_pdu_t::code

request method (value 1–10) or response code (value 40-255)

Definition at line 287 of file pdu.h.

## data

uint8_t* coap_pdu_t::data

first byte of payload, if any

Definition at line 297 of file pdu.h.

## hdr_size

uint8_t coap_pdu_t::hdr_size

actaul size used for protocol-specific header

Definition at line 289 of file pdu.h.

## max_delta

uint16_t coap_pdu_t::max_delta

highest option number

Definition at line 292 of file pdu.h.

## max_hdr_size

uint8_t coap_pdu_t::max_hdr_size

space reserved for protocol-specific header

Definition at line 288 of file pdu.h.

## max_size

size_t coap_pdu_t::max_size

maximum size for token, options and payload, or zero for variable size pdu

Definition at line 295 of file pdu.h.

## tid

uint16_t coap_pdu_t::tid

transaction id, if any, in regular host byte order

Definition at line 291 of file pdu.h.

## token

uint8_t* coap_pdu_t::token

first byte of token, if any, or options

Definition at line 296 of file pdu.h.

## token_length

uint8_t coap_pdu_t::token_length

length of Token

Definition at line 290 of file pdu.h.

## type

uint8_t coap_pdu_t::type

message type

Definition at line 286 of file pdu.h.

## used_size

size_t coap_pdu_t::used_size

used bytes of storage for token, options and payload

Definition at line 294 of file pdu.h.

The documentation for this struct was generated from the following file:

- pdu.h